CC       = CL
SDIR     = ..\src
IDIR     = ..\..\libscl\ms
LDIR     = ..\..\libscl\ms
CFLAGS   = -WL -EHsc -nologo -TP -c -I$(IDIR)

HEADERS = libsmm.h libsmm_base.h $(IDIR)\libscl.h

OBJECTS  = mcmc.obj proposal.obj likehood.obj asymptotics.obj

libsmm.lib : $(HEADERS) $(OBJECTS)
	copy $(SDIR)\*.h .
	lib -out:c:\temp\libsmm.lib $(OBJECTS)
	copy c:\temp\libsmm.lib libsmm.lib
	del  c:\temp\libsmm.lib

libsmm.h : $(SDIR)\libsmm.h
        copy $(SDIR)\libsmm.h libsmm.h

libsmm_base.h : $(SDIR)\libsmm_base.h
        copy $(SDIR)\libsmm_base.h libsmm_base.h

mcmc.obj : $(SDIR)\mcmc.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\mcmc.cpp

proposal.obj : $(SDIR)\proposal.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\proposal.cpp

likehood.obj : $(SDIR)\likehood.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\likehood.cpp

asymptotics.obj : $(SDIR)\asymptotics.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\asymptotics.cpp

clean :
	del *.obj

veryclean :
	del *.obj
	del *.h
	del libsmm.lib

