CC       = CL
SDIR     = ..\src
IDIR     = ..\..\libscl\ms
LDIR     = ..\..\libscl\ms
CFLAGS   = -WL -EHsc -nologo -TP -c -I$(IDIR)

HEADERS  = libsnp.h squash.h $(IDIR)\libscl.h

OBJECTS  = storage.obj drinv.obj factor.obj \
	snpden.obj afunc.obj ufunc.obj rfunc.obj

libsnp.lib : $(HEADERS) $(OBJECTS)
	lib -out:c:\temp\libsnp.lib $(OBJECTS)
	copy c:\temp\libsnp.lib libsnp.lib
	del  c:\temp\libsnp.lib

libsnp.h : $(SDIR)\libsnp.h
	copy $(SDIR)\libsnp.h libsnp.h

squash.h : $(SDIR)\squash.h
	copy $(SDIR)\squash.h squash.h

storage.obj : $(SDIR)\storage.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)/storage.cpp

drinv.obj : $(SDIR)\drinv.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\drinv.cpp

factor.obj : $(SDIR)\factor.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\factor.cpp

snpden.obj : $(SDIR)\snpden.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\snpden.cpp

afunc.obj : $(SDIR)\afunc.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\afunc.cpp

ufunc.obj : $(SDIR)\ufunc.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\ufunc.cpp

rfunc.obj : $(SDIR)\rfunc.cpp $(HEADERS)
	$(CC) $(CFLAGS) $(SDIR)\rfunc.cpp

clean :
	del *.obj

veryclean :
	del *.obj
	del *.h
	del libsnp.lib

