#include <sstream>
#include <cerrno>
#include "libscl.h"
#include "libsnp.h"


using namespace scl;
using namespace std;


realmat RLT(realmat& rets, REAL& beta, INTEGER& T, INTEGER& freq, vector<REAL>& uvec) {
  INTEGER N = uvec.size(); 
  realmat output(T,N,0.0);
  for (INTEGER t=1; t<=T; t++) {
    for (INTEGER i=1; i<=N; i++) {
      for (INTEGER j=1; j<=freq; j++) {
        REAL temp = pow(2.0*freq*uvec[i-1],1.0/beta)*rets((t-1)*freq+j,1);
        output(t,i) += cos(temp);
      }
      output(t,i)/=REAL(freq);
    }
  }
  return output;
}

realmat LT(realmat& vol, INTEGER T, INTEGER freq, vector<REAL>& uvec) {
  INTEGER N = uvec.size();
  realmat output(T,N,0.0);

  for (INTEGER t=1; t<=T; t++) {
    for (INTEGER i=1; i<=N; i++) {
      for (INTEGER j=1; j<=freq; j++) {
        output(t,i) += exp(-uvec[i-1]*vol[(t-1)*freq+j]);
      }
      output(t,i)/=REAL(freq);
    }
  }
  return output; 
}


realmat JLT(realmat& data, INTEGER& K) {
 INTEGER T = data.nrow(); INTEGER N = data.ncol();
 realmat output(N,N,0.0);
 for (INTEGER i=1; i<=N; i++) {
    for (INTEGER j=1; j<=N; j++) {
       for (INTEGER t=K+1; t<=T; t++) {
          output(i,j) += data(t,i)*data(t-K,j);
       }
       output(i,j)/=REAL(T-K);
    }
 }
 return output; //(i,j) element corresponds to i-th current element and j-th lagged
}

